/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getDateOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getDateOperationDispatcher. It contains of all the generic methods
    for getDateOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getDateOperationDispatcher_HXX
#define getDateOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getDateOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getDateOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getDateOperationDispatcher();
        virtual ~getDateOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getDatePreConditions( const Teamcenter::BusinessObject* obj, date_t& dateValue, bool& isNull ) const;
        void getDatePreActions( const Teamcenter::BusinessObject* obj, date_t& dateValue, bool& isNull ) const;
        void getDateBaseAction( const Teamcenter::BusinessObject* obj, date_t& dateValue, bool& isNull ) const;
        void getDatePostActions( const Teamcenter::BusinessObject* obj, date_t& dateValue, bool& isNull ) const;

        // Project 011450 changes
        void getDatePreConditions( METHOD_message_t*  msgData, date_t* value, logical* isNull ) const;
        void getDatePreActions( METHOD_message_t*  msgData, date_t* value, logical* isNull ) const;
        void getDateBaseAction(METHOD_message_t*  msgData, date_t* value, logical* isNull ) const;
        void getDatePostActions( METHOD_message_t*  msgData, date_t* value, logical* isNull ) const;

        void getDate( const Teamcenter::BusinessObject* obj, date_t& dateValue, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getDateOperationDispatcher_HXX
